/*  =========================================================
    SING - ALONG DISK PLAYER. 
    (C) 1998, 1999   Michael Glickman.  xsadp@yahoo.com       
    ----------------------------------------------------------
    NOTICE:
            Sing-Along Disk Player is copyrighted by the author.
            See COPYRIGHT regarding distribution policy and
            conditions of use.

            You are expected to provide appropriate references
            when using a part of the code in your software. 

	    Author strongly advices against using this code, or
	    a part of it, in an application designed to run  on
	    any Microsoft(tm) platfrom.
    ========================================================= */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include "sadp_config.h"
/*
  static char *SadpEpilogue =
  "\n\nIf you enjoyed SADP, try another author's \"creation\":\n\n"
  "Intelligent TETRIS - enjoy playing the eternally young game\n"
  "                     listening to your favourite tunes,  or\n"
  "                     have a rest and watch how the computer\n"
  "                     can do it for you!\n\n"  
  "X and svgalib versions are available.  The  svgalib version\n"
  "supports different video-modes and is expected to work with\n"
  "EGA, VGA and all superVGA cards,even not supported directly\n"
  "by svaglib. Available at:\n"                      
  "  ftp://sunsite.unc.edu/pub/Linux/games/arcade/tetris\n\n"
  "Your comments (no matter how good they are) are valuable.\n"
  "Send your email to xsadp@yahoo.com\n\n"
  "Bye till 1999.\n\n";
*/  

char  *HelpPages[] = 
     {"#         HINTS.           ",	
#ifdef X11
	"#- Increase window size to ",
	"#  get more on a page.     ",
#else
	"#  Use high screen res to  ",
	"#  get more on a page (see ",
	"#  manual for details).    ",
#endif
	"#- Unless specified other- ",
	"#  wise, key equivalents   ",
      "#  are case InSEnSiTiVe.   ",
      "                           ",    
#ifdef X11
      "%   HELP-INFO-MISC still   ",    
#else      
      "%     HELP-INFO-MISC       ",    
#endif      
      "81  PREV COLUMN      Left  ",
      "82  NEXT COLUMN      Right ",
      "83  NEXT PAGE        Down  ",
      "80  PREV PAGE         Up   ",
      "88x LAST PAGE         End  ",
      "89x FIRST PAGE       Home  ",
      "84x SLIDE FORWARD    Space ",
      "85x SLIDE BACK       Back  ",
/*      "76x NEXT SECTION     PgDn  ",
        "75x PREV SECTION     PgUp  ",  */

#ifdef X11
      "                           ",    
      "%   HELP-INFO-MISC slide   ",    
      " - Speed increases,if arrow",    
      "   points toward sliding.  ",
	" - FINE commands provide   ",
	"   smaller speed adjustment",
      "                           ",    
      "91x FINE SPEED FWD    Left ",
      "92x FINE SPEED BACK  Right ",
      "93x CHANGE SPEED FWD  Down ",
      "90x CHANGE SPEED BACK  Up  ",
      "98x MAX/MIN  SPEED    End  ",
      "99x MIN/MAX  SPEED    Home ",
      "97x STOP SLIDING Spce Back ",
#endif      
      "                           ",    
      "#       CD control         ",    
      "78x PLAY/RESUME     Space  ",
      "77x    PAUSE        Space  ",
      "71x STOP             Ins   ",
      "72x    EJECT         Ins   ",
      "70x         LOAD     Ins   ",
      "                           ",
      "#    PLAYBACK control      ",    
      "1x  BACK             Left  ",
      "2x  FORWARD          Right ",
      "3x  NEXT TRACK       Down  ",
      "0x  PREV TRACK        Up   ",
      "9xx FORW 5 TRACKS    PgDn  ",
      "8xx BACK 5 TRACKS    PgUp  ",
#ifdef X11
      "18x FIRST TRACK      Home  ",
      "17x LAST  TRACK      End   ",
#else
      "    FIRST TRACK      Home  ",
      "    LAST  TRACK      End   ",
#endif      
#ifdef CHANGER_SUPPORT
      "                           ",
      "#   CD CHANGER control     ",    
      "    NEXT  SLOT          o  ",
      "    PREV  SLOT          O  ",
#endif
      "                           ", 
#ifdef MIXER_SUPPORT
      "#     MIXER control        ",    
      "11  NEXT DEVICE         >  ",
      "10  PREVIOUS DEVICE     <  ",
      "    VOLUME UP           ]  ",
      "    VOLUME DOWN         [  ",
      "    BALANCE LEFT        {  ", 
      "    BALANCE RIGHT       }  ", 
      "    INPUT ON / OFF      '  ",
      "                           ", 
#endif
      "#   TIME DISPLAY modes     ",    
      "  t - next mode, T - prev  ",
      "40x TIME ELAPSED       t T ",
      "41x TIME REMAINED      t T ",
      "42x PERCENTAGE ELAPSED t T ",
      "43x PERCENTAGE REMAIN  t T ",
      "                           ", 
      "#      PLAY options        ",    
      "44x AUTO-PLAY ON        A  ", 
      "45x AUTO-PLAY OFF       A  ", 
      "51x LOOP PLAY ON        L  ", 
      "52x LOOP PLAY OFF       L  ", 
      "                           ", 
      "#      PLAY MODES          ",    
      "  p - next mode, P - prev  ",
      "46x NORMAL             p P ",
      "47x PLAY LIST          p P ",
      "48x RANDOM ORDER       p P ",
      "49x INTRODUCTION       p P ",
      "50x SINGLE TRACK       p P ",
      "                           ", 
#ifdef DSP_SUPPORT
      "# SPECTRUM & OSCILLOSCOPE  ",    
#ifdef X11      
      " INCREASE BAR WIDTH      w ",
      " REDUCE BAR WIDTH        W ",
      " INCREASE INTERLACE VAL  i ",
      " REDUCE INTERLACE VAL    I ",
      " CHANGE SPECTRUM DISPLAY D ",
      " INCREASE GAIN VAL       g ",
      " REDUCE GAIN VAL         G ",
      " INCREASE PIXEL WIDTH    w ",
      " REDUCE PIXEL WIDTH      W ",
      " INCREASE PIXEL HEIGHT   h ",
      " REDUCE PIXEL HEIGHT     H ",
      " INCREASE WAVE V-SCALE   v ",
      " REDUCE WAVE V-SCALE     V ",
      " TOGGLE OBTURATION  CTRL+O ",
      " TOGGLE STEREO      CTRL+S ", 
#else 
      "INCREASE GAIN /         g  ",
      "REDUCE      WAVE SCALE  G  ",
      "INCREASE INTERLACE /    i  ",
      "REDUCE      OBTURATION  I  ",
#endif      
       
#endif
      "                           ", 
      "#    DISC INFO EDITOR      ",    
      "    MOVE LEFT        Left  ",
      "    MOVE RIGHT       Right ",
      "    NEXT TRACK       Down  ",
      "    PREV TRACK        Up   ",
/*      "    FIRST TRACK      Home  ", 
      "    LAST TRACK       End   ",  */
      "    ERASE PREVIOUS  Backsp ",
      "    NEXT FIELD        Tab  ",
      "    PREV FIELD      Sh+Tab ",
      "    SAVE            Ctrl+S ",
      "    RELOAD          Ctrl+L ",
      "    DOWNLOAD        Ctrl+D ",
      "    UPLOAD          Ctrl+U ",
      "    CHANGE BROWSER     F6  ",
#ifdef X11
      "    ADD TO PLAYLIST   Ins  ",
      "               Shift+Right ",
      "    REMOVE FROM LIST  Ins  ",
      "                Shift+Left ",
#else      
      "    ADD TO PLAYLIST   Mdle ",
      "               Shift+Right ",
      "    REMOVE FROM LIST  Mdle ",
      "                Shift+Left ",
#endif      
      "                           ",
#ifdef RCDDB_SUPPORT
      "#     RCDDB PANEL          ",    
      "    GUESS           Ctrl+G ",
      "    CDDBP/HTTP      Ctrl+P ",
#ifdef X11      
      "    UPDATE SITES    CTRL+U ",
#else      
      "    UPDATE SITES    CTRL+T ",
#endif      
      "    RAISE SITE    Shift+Up ",
      "    LOWER SITE    Shift+Dwn",
      "    DELETE SITE   Shift+Del",
      "                           ",
#endif
      "#     OTHER COMMANDS       ",    
/*        "13x HELP/INFO        H or ?", */
      "79x TOGGLE KBD FOCUS   F5  ",
#ifdef X11
      "15x SUSPEND             S  ",
#else      
      "    SUSPEND             S  ",
#endif      
      "14x REFRESH             R  ",
      "16x SAVE OPTIONS       F10 ",
#ifdef X11
      "    NEXT BOTTOM PANEL  F1  ",
      "    PREV BOTTOM PANEL  F2  ",
#else
      "19x NEXT BOTTOM PANEL  F1  ",
      "18x PREV BOTTOM PANEL  F2  ",
#endif      
      "6xx QUIT                Q  ",
      "12x STOP and QUIT       Z  ",
      "                           ",
      "%        SLIDERS           ",    
      "%- Click or drag a slider! ",
      "%- Tops sliders are used   ",
      "%  for selecting playing   ",
      "%  track, or position in   ",
      "%  the current track.      ",
      "%- The bottom slider sets  ",
      "%  position in help text.  ",
      "                           ",
      "#         MOUSE            ",
#ifdef X11
      " Left button - press.      ",
#else 
      "Left button - operate.     ",
      "Middle and right buttons - ",
      "associate a function or    ",
      "perform associated function",
#endif
      "                           ",
      "#         MORE             ",
      "For details and trouble -  ",
      "shooting refer to man page."
};

const short HelpWidth = 26;
const short HelpLineCount = sizeof(HelpPages) / sizeof(char *);

char *MiscPages[] =
{ 
#ifdef X11
  "          Sing-Along Disc Player ",
  "          A lot of new features! ",
  "                                 ",
  "          by Abandoned Computer  ",
  "             Enthusiast  (ACE)   ",
 #else 
  "   @@@@   @@@@        @ @@@@@@   ", 
  "  @    @ @    @       @ @     @  ",
  "  @           @       @ @     @  ",
  "   Sing   Along   Disc@ Player   ",
  "       @ @    @  @    @ @        ",
  "  @    @ @    @  @    @ @        ",
  "   @@@@   @@@@ @  @@@@@ @        ",
  "                                 ",
  "=================================",
  "See home page for new features!  ",
  "By Abandoned Computer Enthusiast.",
#endif  
/*  
  "A new year present to Linux users",
  "By Abandoned Computer Enthusiast.",
  "Version 1.0         Nov-Dec. 1998",
*/  
  "Version 3.1         Mar-Apr. 2000",
  "                                 ", 
  "%   DEVELOPMENT ENVIRONMENT      ", 
  "CPU:                             ",
  "  - Intel Pentium(tm) MMX 166MHz ", 
  "  - Intel(tm) 80486DX 66MHz      ", 
  "                                 ", 
  "CDs:                             ",
  "  - Panasonic CW-7502            ", 
  "  - AOpen 40x (IDE)              ", 
  "  - Creative/Panasonic CR-563    ",  
  "    SCSI CONTROLLER: NCR53810A   ",
  "  Drivers by Scott Snyder,       ",
  "  Eberhard Moenkeberg, David     ",
  "  Giller, Wolfgang Stanglmeier   ",
  "                                 ", 
  "SOUND CARDS:                     ",
  "  - Gravis Ultrasound            ", 
  "  - Sound Blaster 16 (1994)      ", 
  "  - Sound Blaster AWE-64         ", 
  "                                 ",
  "SOUND DRIVERS:                   ",
  "  - OSS 3.50 by Hannu Savolainen ",
  "    and  4front Technologies     ",
  "  - Linux Sound Driver 0.1.0     ",
  "  - Advanced Linux Sound         ",
  "    Architecture 0.4.1f2 and     ",
  "    0.5.6  by Jaroslav Kysela    ",
  "    and ALSA team                ",
  "                                 ",
  "VIDEO CARDS:                     ",
  "  - Diamond Stealth 3D Pro       ",
  "  - Trident TGUI 9440            ",
  "  - Cirrus Logic GD5426          ",
  "                                 ",
  "%    DEVELOPMENT  SYSTEM         ",
  "  OS: Linux 2.2.9, 2.3.23, 2.0.36",
#ifdef X11
  "  X-SERVER: XFree86 3.3.2, 3.1.2 ",
  "                                 ",
  "WINDOW MANAGERS:                 ",				
  "  fvwm 1.23b by Robert Nation    ",
  "  Window Maker 0.20.1 and 0.60.0 ",
  "           by  Alfredo K. Kojima ",
  "  kwm 0.11/13 by Matthias Ettric ",
#endif  
  "                                 ",
  "%    DEVELOPMENT SOFTWARE        ",
  " gcc 2.7.2, make 3.74, gdb 4.5.11",
  "     by Free Software Foundation ", 
  "                                 ",
  "TEXT EDITORS:                    ", 
#ifdef X11  
  " - cooledit 3.11.6 by Paul Sheer ",
#else  
  " - we 1.5.8a by Fred Kruse       ",   
#endif  
  " - vim 5.3 by Bram Moolenar et al",
  " - elvis 1.8.pl3 (alias 'vi')    ",
  "         by Steve Kirkendall     ",
  "                                 ",
#ifdef X11
  "GRAPHIC EDITORS:                 ",
  " - Resource Workshop 1.02 by     ",  
  "   Borland(tm) International Inc ", 
  " - xv 3.10 by John Bradley       ",  
  " - bitmap  by Davor Matic        ",  
  " - xpaint 2.4.9 by David Koblas  ", 
  "   and Torsten Martinsen         ",
  "                                 ",
#endif  
  "LIBRARIES:                       ",
#ifdef X11  
  " - XForms 0.89, 0.88, 0.86, 0.81 ",
  "   by T.C.Zhao & Mark Overmars   ",
#else  
  " - libncurses 5.0, 4.2, 1.9.9e   ",
  "   by Zeyd Ben-Halim,Eric Raymond",
  "   and Thomas Dickey             ",
  " - libgpm v1.14                  ",
  "   by Alessandro Rubini          ",
#endif  
  "                                 ",
  "%      DOCUMENTATION USED        ",
#ifdef X11  
  "  - \"Forms Library. A Graphical  ",
  "    User Interface Toolkit for X\"",
  "    by T.C.Zhao and Mark Overmars",
  "  - \"Advanced  X-Window Applica- ",
  "    tions Programming\" by Eric F.",
  "    Johnson and Kevin Richards   ",
  "    2nd edition M&T Books 1994   ",
#endif  
  "  - cdrom.h header file          ",
  "    by David Giller,  Eberhard   ",
  "    Moenkeberg and Jens Axboe    ",
  "  - soundcard.h and OSS on-line  ",
  "    spec by Hannu Savolainen     ",
  "  - CDDB protocol specification  ",
  "    (cddb.howto) by CDDB Inc.    ",
  "  - CD-INDEX online information  ",
  "    and sample XML files         ",
  "  - SMTP specification edited    ",
  "    by John C. Klensin           ",
  "  - SCSI MMC-2 NCITS draft r.11a ",
  "    by Sierra-Pack Technology    ",
  "    editor Ron Roberts           ",
  "  - ALSA library API by Jaroslav ",
  "    Kysela, Abramo Bagnara, Frank",
  "    van de Pol and Takashi Iwai  ",
  "                                 ",
  "SOURCE CODE CONSULTED:           ",
  "   libcdaudio by Tony Arcieri    ",
  "   alsalib   by ALSA team        ",
  "   wavplay   by Warren Gay       ",
  "   aplay     by Jaroslav Kysela  ",
  "   cam mixer by Jan Vandenberghe ",
  "   amixer    by Jaroslav Kysela  ",
  "   xcd       by Sean Vyain       ",
  "   cdindex   by Robert Kaye      ",
  "   gpm       by Alessandro Rubini",
  "   setcd     by David van Leeuwen",
#ifdef NATIONAL_FONT
  "   cdda2wav  by Heiko Eissfeldt  ",
#else
  "   cdda2wav  by Heiko Eifeldt   ",
#endif
  "                                 ",
  "%           CREDITS              ",
  " -  Prof. Robert Sedgewick       ",	
  "    for the idea of using complex",
  "    roots of  unity  in  Fourier ",
  "    Transform (\"Algorithms in C\",",
  "    Addison-Wesley, 1990)        ",
  " -  Pascal and DOJ               ",
  "   (Niklas Beisert,Dirk Jagdmann)",
  "    the creators of Cubic Player ",
  " -  Dirk Foersterling for fresh  ",
  "    ideas came to sadp from the  ",
  "    new WorkMan data base        ",
  " -  Andy Lo A Foe for a subtle   ",
  "    but significant information  ",
  "                                 ",
  "THANKS TO WWW CORRESPONDENTS FOR ",
  "HELP, BUG REPORTS, COMMENTS  AND ",
  "FRESH IDEAS (alphabetic order):  ",
  " Julie Brandon,  Edwin Chan,     ",
  " Robin Cosby,  Thomas Dickey,    ",
  " Tano Fotang,  Bill Grzanich,    ",
  " Jeff Hayes, Mike Hakes, Petra   ",
#ifdef NATIONAL_FONT
  " Harjamaki, Ru Igarashi, Roeland ",
#else
  " Harjamki, Ru Igarashi, Roeland ",
#endif
  " Th. Jansen,  Jonathan Larmour,  ",
  " An Thi-Nguyen Le,  Maurizio     ",
  " Loreti, Pawel Olszewski, Gabor  ",
  " Z. Papp, Bob van der Poel,      ",
  " Rangel Reale, Marc D. Williams, ",
  " Paul Sheer, T.C. Zhao           ",
  "                                 ",
  "SPECIAL THANKS:                  ",
  " - RubiXcom (Alfred Glickman)    ",
  "   for artwork,home page design, ",
  "   suggestions and comments      ",
#ifdef NATIONAL_FONT
  " - Jens Axboe, Heiko Eissfeldt   ",
  "   and Andreas Mueller for       ",
#else
  " - Jens Axboe, Heiko Eifeldt    ",
  "   and Andreas Mller for        ",
#endif
  "   CD extension know-how         ",
  " - Robert Kaye, Michael Kaiser   ",
  "   for cooperation in accessing  ",
  "   remote CD data bases          ",
  " - Bill Grzanich for significant ",
  "   contribution to Ensoniq sound ",
  "   cards support                 ",
  " - Roy George for his ESS-1868   ",
  " - Nathan Bailey for his Linux   ",
  "   reference page                ",
  "                                 ",
  "% GREETINGS TO VOLUNTEER  LINUX  ",
  "% SUPPORTERS ALL OVER THE WORLD! ",
  "+-------------------------------+",
  "|       tWips oN the Way:       |",
  "|                               |",
  "|  Sing-Along  Disk  Player is  |",
  "|  an exclusive Linux product.  |",
  "|  Enjoy music with SADP,  and  |",
  "|  say NO! to ... everyone who  |",
  "|  does not appear to like it.  |",
  "+-------------------------------+"
};

const short MiscWidth = 33;
const short MiscLineCount = sizeof(MiscPages) / sizeof(char *);


void print_epilogue(void)
{  

/*  puts(clear_screen);
    puts(cursor_home);
*/    
/*    puts(SadpEpilogue); */
    ;
}    
