#define SADP_BLACK FL_ORCHID
#define SADP_YELLOW FL_DARKCYAN

#define PIXEL_MIN_WIDTH 1
#define PIXEL_MIN_HEIGHT 1
#define PIXEL_MAX_WIDTH 12
#define PIXEL_MAX_HEIGHT 12

#define BAR_MIN_WIDTH 1
#define BAR_MAX_WIDTH 30

#if FL_INCLUDE_VERSION < 86
typedef FL_Coord FL_COORD;
enum
{ FL_LEFT_MOUSE=1, FL_MIDDLE_MOUSE, FL_RIGHT_MOUSE};
#define fl_set_object_lcolor  fl_set_object_lcol
#endif 

typedef enum 
{
  PLACEMODE_NORMAL,
  PLACEMODE_MAX,
  PLACEMODE_ICON,
  PLACEMODE_CENTRE,
  PLACEMODE_HIDDEN
} PLACE_MODE_TYPES;       

#ifdef ICON_WINDOW_SUPPORT
typedef enum
{
  ICONSTYLE_STATIC,
  ICONSTYLE_WINDOW,
  ICONSTYLE_DUAL
} ICON_STYLE_TYPES;
#endif


enum FOLDER_TAB
{      FOLDER_SPECTRUM, FOLDER_WAVE,
       FOLDER_DATA,
#ifdef RCDDB_SUPPORT
                       FOLDER_RCDDB,
#endif		       
       FOLDER_HELP,     FOLDER_STATUS,
       FOLDER_MISC,	FOLDER_NONE
};	
#ifdef RCDDB_SUPPORT
#define FOLDER_BUTTONS 8
#else
#define FOLDER_BUTTONS 7
#endif

enum RCDDB_CONTROL_INDICES
{
    RCDDB_USER,         RCDDB_PROXYON,
    RCDDB_PROXYADDR,    RCDDB_MAILADDR,
    RCDDB_GUESS,        RCDDB_SITELIST,
    RCDDB_HIDDEN,       RCDDB_UP,
    RCDDB_DELETE,	RCDDB_DOWN, 	
    RCDDB_TEXT1,
    RCDDB_PROTCHOICE,   RCDDB_REFRESH
    
        
};    
    
int start_xformsing(int *argc, char *argv[]); 
KeySym xforms_get_last_key(void);

void fill_help_headers(FL_OBJECT *obj);
void fill_browser_line(FL_OBJECT *obj, int selection);
int  advance_browser(FL_OBJECT *obj, int key);
void input_processing(FL_OBJECT *obj);
int xforms_close_routine(FL_FORM *ign1, void *ign2);

/* Drawing functions */
extern void xforms_draw_suspend(FL_COORD x, FL_COORD y,  FL_COORD w, FL_COORD h,
			     int angle, FL_COLOR col);
extern void xforms_draw_refresh(FL_COORD x, FL_COORD y,  FL_COORD w, FL_COORD h,
			     int angle, FL_COLOR col);
extern void xforms_draw_skip(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
		             int angle, FL_COLOR col);
extern void xforms_draw_next(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
		             int angle, FL_COLOR col);
extern void xforms_draw_fwd(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
		             int angle, FL_COLOR col);
extern void xforms_draw_stop(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
		             int angle, FL_COLOR col);
extern void xforms_draw_first(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
		             int angle, FL_COLOR col);
extern void xforms_draw_stopquit(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
			     int angle, FL_COLOR col);
extern void xforms_draw_play(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
			     int angle, FL_COLOR col);
extern void xforms_draw_pause(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
			     int angle, FL_COLOR col);
extern void xforms_draw_saveo(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
			     int angle, FL_COLOR col);
extern void xforms_draw_eject(FL_COORD x, FL_COORD y, FL_COORD w, FL_COORD h,
			     int angle, FL_COLOR col);

void set_bottom_section(short NewSection);

void help_xforms_initialize(void);
void help_show_page(long start);
void help_slider_callback(FL_OBJECT *obj, long par);
void help_btn_callback(FL_OBJECT *obj, long par);

void set_window_icon_name(const char *icon_name);
long  win_state(Window wnd);
short  win_visibility(Window wnd);

void help_prepare_canvas(int mode);
void help_unprepare_canvas(void);
int  help_canvas_callback(FL_OBJECT *obj, Window win, 
		      int win_width, int win_height,
		      XEvent *xev, void *user_data);
void help_xforms_deinitialize(void);

void help_idle_callback(void);

/* Data panel */
int fill_track_list(FL_OBJECT *brow_tracks);
short accept_play_list(FL_OBJECT *brow_playlist);
int fill_track_list(FL_OBJECT *brow_tracks);
int insert_play_list_line(FL_OBJECT *obj, short trk_no);
int delete_play_list_line(FL_OBJECT *obj);
int fill_play_list(FL_OBJECT *brow_playlist);


void set_tooltip(FL_OBJECT *obj, const char *text);
void set_tooltip_text(FL_OBJECT *obj, const char *text);
void show_tooltip(FL_OBJECT *obj, short align);
void hide_tooltip(void);
void disable_tooltip(void);
int is_tooltip_on(void);

void xforms_submit_data(void);
void rcddb_xforms_initialize(void);
void rcddb_xforms_deinitialize(void);
void rcddb_callback(FL_OBJECT *obj, long par);
short rcddb_download_data(void);

void rcddb_got_focus(void);
		    
void icon_control_init(void);
void icon_control_deinit(void);
int  icon_control_callback(XEvent *xev, void *data);
void show_icon_progress(long elapsed, long duration, int ind);
void draw_icon_track_number(short trackno);
void clear_icon_spectrum(int ind);
void clear_icon_time(void);
void set_icon_stop_button(short ind);
void init_icon_nonaudio(void);
void icon_idle_callback(void);

void correct_play_list(FL_OBJECT *brow_playlist, int trk_no);
int process_imwheel(XEvent *xev);

#if FL_INCLUDE_VERSION > 88
void  help_refresh_canvas(void);
#endif
